//=============================================================================
// Ez-RoboMaster Test Program - DX Motor Test
//
// by (jh.park@ezlab.com)
// [dx_arm.h]
//=============================================================================

/*
 - DX-Motor ̿ κ  ⺻   
*/

//Ez-RoboMaster API 
#include "c:\winavr\ezrobomaster\ezrmlib.h"
#include "c:\winavr\ezrobomaster\rm_dxmotor.h"


void InitArm(void);
void arm_Move(unsigned int *pArmPos);
void amr_MovePos(unsigned int ArmPos1, unsigned int ArmPos2, unsigned int ArmPos3);
void arm_MoveTo(unsigned int ArmPos1, unsigned int ArmPos2, unsigned int ArmPos3);
void arm_GetArmPos(unsigned int *pArmPos);

//-----------------------------------------------------------------------------
// ARM Control Function
//-----------------------------------------------------------------------------
#define ARM_STATUS_UP						1
#define ARM_STATUS_DOWN						2
#define ARM_STATUS_SCAN						3

#define ARM_MOTOR1							1
#define ARM_MOTOR2							2
#define ARM_MOTOR3							3

#define MAX_ARM_SPEED						150

//Arm Robot ʱȭ Լ
void InitArm(void)
{
	DxmInit();	
}

// ġ  ͸ ÿ  ϴ Լ
//Ͱ 3 ϰ 
void arm_Move(unsigned int *pArmPos)
{
	// ġ  ӵ  
	DxmSetReg(ARM_MOTOR1, pArmPos[0], MAX_ARM_SPEED);
	DxmSetReg(ARM_MOTOR2, pArmPos[1], MAX_ARM_SPEED);
	DxmSetReg(ARM_MOTOR3, pArmPos[2], MAX_ARM_SPEED);
	
	// 
	DxmAction();			
}

// ġ ͸   ->3  ġ 
void amr_MovePos(unsigned int ArmPos1, unsigned int ArmPos2, unsigned int ArmPos3)
{
	unsigned int pos[3];
	
	pos[0] = ArmPos1;
	pos[1] = ArmPos2;
	pos[2] = ArmPos3;
	
	arm_Move(pos);	
}

//͸  ġ    
void arm_MoveTo(unsigned int ArmPos1, unsigned int ArmPos2, unsigned int ArmPos3)
{
	DxmRunOut(ARM_MOTOR1, ArmPos1, MAX_ARM_SPEED);
	Delay(400);
	DxmRunOut(ARM_MOTOR2, ArmPos2, MAX_ARM_SPEED);
	Delay(400);	
	DxmRunOut(ARM_MOTOR3, ArmPos3, MAX_ARM_SPEED);
}

// ġ о  Լ
void arm_GetArmPos(unsigned int *pArmPos)
{
	unsigned int pos;

	// ġ о
	pos = DxmGetPos(ARM_MOTOR1);
	pArmPos[0] = pos;
	Delay(300);

	pos = DxmGetPos(ARM_MOTOR2);
	pArmPos[1] = pos;
	Delay(300);
	
	pos = DxmGetPos(ARM_MOTOR3);
	pArmPos[2] = pos;
	Delay(300);
}
//-----------------------------------------------------------------------------
